View Issue Details

IDProjectCategoryView StatusLast Update
0001653NoesisGUIUnity3Dpublic2020-04-16 19:19
ReporterstonstadAssigned Tosfernandez 
PrioritynormalSeveritycrashReproducibilityrandom
Status resolvedResolutionfixed 
Product Version3.0 
Target Version3.0.0Fixed in Version3.0.0 
Summary0001653: Noesis_View_Update(...) Hard Locks Unity
DescriptionUsing Noesis 3.0 b6, I am seeing a repeated Unity hard lock. I can attach to the Unity Editor process and get the call stack.

The only thread executing code (and blocking) is Noesis_View_Update(CPtr, timeInSeconds). I can set a breakpoint on line 260 and confirm that it does not fire because code remains stuck on line 261. See enclosed screenshots.

TagsNo tags attached.
PlatformAny

Activities

stonstad

stonstad

2020-04-09 22:15

reporter  

Lock-Active-Threads.PNG (44,285 bytes)
Lock-Active-Threads.PNG (44,285 bytes)
Lock-Location.PNG (70,104 bytes)
Lock-Location.PNG (70,104 bytes)
sfernandez

sfernandez

2020-04-10 12:23

manager   ~0006186

In Unity we don't explicitly use the Dispatcher, so there shouldn't be any operations pending when processing the dispatcher queue.
The code for the Dispatcher is also available, could you please check how many 'pendingOperations' are being processed when it freezes, or if it is frozen inside any of the operations being invoked?
stonstad

stonstad

2020-04-10 15:31

reporter   ~0006187

I believe the freeze is on Noesis_View_Update because this is the method shown in the Unity Editor call stack when I attach to the editor. This is also the line that has the yellow program counter highlighted. The red line is just my breakpoint to see if Update is called later. I'll check the dispatcher queue.

FWIW -- this is happening to me very frequently.
sfernandez

sfernandez

2020-04-10 20:44

manager   ~0006189

Sorry, I misunderstood.
Could you please attach a Visual Studio debugger, hit "Pause" button, and then go to "Debug > Save Dump As...".
This is using beta 6, right? We'll try to see where inside Noesis it is stuck.
stonstad

stonstad

2020-04-10 21:47

reporter   ~0006193

Is the minidump ok?

Actual Editor.PNG (70,917 bytes)
Actual Editor.PNG (70,917 bytes)
Unity.dmp (1,715,540 bytes)
sfernandez

sfernandez

2020-04-12 12:45

manager   ~0006194

The minidump is ok, thank you. We will study it and keep you informed.
sfernandez

sfernandez

2020-04-12 12:48

manager   ~0006195

One question, are you manually updating and rendering our View, or you are simply using our NoesisView component?
jsantos

jsantos

2020-04-13 16:41

manager   ~0006197

We know what's happening but we need more information about when this is happening. If you have a pattern that fires this issue it is really welcome. :)
stonstad

stonstad

2020-04-13 17:48

reporter   ~0006198

I am letting the Noesis View handle updating and rendering. @jsantos -- it seems to happen only when I am in the Unity Editor scene view. It does not happen in the game view, I think. Otherwise, it is very random. I have had it happen five times in five minutes -- and I can go several hours without it happening. I think it relates to what I am doing in the Editor Scene view -- if I am moving and/or manipulating object transforms that seems to cause it. Despite the call stack, maybe it is Unity caused.

Would a full dump instead of a minidump help?
jsantos

jsantos

2020-04-13 17:52

manager   ~0006199

Thanks, we don't need more dumps. We know what part of our code is causing this.

So this is not happening in PLAY mode?
stonstad

stonstad

2020-04-14 15:46

reporter   ~0006200

If I edit or move things in the scene view during playback it happens in a few seconds. Is there something I can do to unfreeze it? When it happens minimize/maximize no longer works once I tab to a different application.
jsantos

jsantos

2020-04-14 15:50

manager   ~0006201

Just let me confirm this, this is only happening during playback right?
stonstad

stonstad

2020-04-14 23:27

reporter   ~0006204

I have more information to share.

1) Only happens during PLAY
2) Only happens when flying around or clicking in Scene tab
3) Only happens when a Noesis View is active.
stonstad

stonstad

2020-04-15 00:05

reporter   ~0006206

Last edited: 2020-04-15 00:06

View 2 revisions

It is a 15GB project. I can send it over with repo steps after this thread is marked private.

jsantos

jsantos

2020-04-15 00:08

manager   ~0006207

Thanks for the details. For we don't need the project.

One question regarding 2), this is happening when going to Scene tab and Game view is not visible right?
stonstad

stonstad

2020-04-15 15:07

reporter   ~0006210

That's right -- my editor is tabbed so that either the scene view or game view is visible, but not both.

My workaround is to always disable the game object containing the NoesisView before I switch to the scene view and inspect game objects.
jsantos

jsantos

2020-04-15 17:01

manager   ~0006211

Thanks for the feedback. We were able to reproduce it. Working on a fix right now.

Issue History

Date Modified Username Field Change
2020-04-09 22:15 stonstad New Issue
2020-04-09 22:15 stonstad File Added: Lock-Subsequent-Attempt.PNG
2020-04-09 22:15 stonstad File Added: Lock-Active-Threads.PNG
2020-04-09 22:15 stonstad File Added: Lock-Location.PNG
2020-04-10 12:23 sfernandez Assigned To => sfernandez
2020-04-10 12:23 sfernandez Status new => feedback
2020-04-10 12:23 sfernandez Note Added: 0006186
2020-04-10 15:31 stonstad Note Added: 0006187
2020-04-10 15:31 stonstad Status feedback => assigned
2020-04-10 20:44 sfernandez Status assigned => feedback
2020-04-10 20:44 sfernandez Note Added: 0006189
2020-04-10 21:47 stonstad File Added: Actual Editor.PNG
2020-04-10 21:47 stonstad File Added: Unity.dmp
2020-04-10 21:47 stonstad Note Added: 0006193
2020-04-10 21:47 stonstad Status feedback => assigned
2020-04-12 12:45 sfernandez Note Added: 0006194
2020-04-12 12:48 sfernandez Status assigned => feedback
2020-04-12 12:48 sfernandez Note Added: 0006195
2020-04-13 16:40 jsantos Target Version => 3.0.0
2020-04-13 16:40 jsantos Description Updated View Revisions
2020-04-13 16:41 jsantos Note Added: 0006197
2020-04-13 17:48 stonstad Note Added: 0006198
2020-04-13 17:48 stonstad Status feedback => assigned
2020-04-13 17:52 jsantos Note Added: 0006199
2020-04-13 17:52 jsantos Status assigned => feedback
2020-04-14 15:46 stonstad Note Added: 0006200
2020-04-14 15:46 stonstad Status feedback => assigned
2020-04-14 15:50 jsantos Note Added: 0006201
2020-04-14 15:50 jsantos Status assigned => feedback
2020-04-14 23:27 stonstad Note Added: 0006204
2020-04-14 23:27 stonstad Status feedback => assigned
2020-04-15 00:05 stonstad Note Added: 0006206
2020-04-15 00:06 stonstad Note Edited: 0006206 View Revisions
2020-04-15 00:08 jsantos Note Added: 0006207
2020-04-15 00:08 jsantos Status assigned => feedback
2020-04-15 15:07 stonstad Note Added: 0006210
2020-04-15 15:07 stonstad Status feedback => assigned
2020-04-15 17:01 jsantos Note Added: 0006211
2020-04-16 19:19 jsantos Status assigned => resolved
2020-04-16 19:19 jsantos Resolution open => fixed
2020-04-16 19:19 jsantos Fixed in Version => 3.0.0